#include <fstream>
#include <vector>

#include "AneuMeshLoader.h"
#include "Exception.h"


void AneuMeshLoader::loadMesh(const string& filename) {
	std::ifstream file(filename);
		if (!file) {
			throw Wrong_file_format();
		}
		cout << "file " << filename << " has opened" << endl;

		int cnt, dim;
		file >> cnt >> dim;
		nodes.reserve(cnt);
		for (size_t i = 1; i <= cnt; i++) {
			size_t id = i;
			std::vector<float> coord(dim);
			for (size_t j = 1; j <= dim; j++) {
				file >> coord[j - 1];
			}
			nodes.emplace_back(id, coord, true);
		}
		file >> cnt >> dim;
		for (int i = 1; i <= cnt; i++) {
			size_t id = i;
			std::vector<size_t> coord(dim);
			size_t materialId;
			file >> materialId;
			for (int j = 1; j <= dim; ++j) {
				file >> coord[j - 1];
			}
			finiteElements.emplace_back(id, materialId, coord);
		}

		file >> cnt >> dim;
		for (int i = 1; i <= cnt; i++) {
			size_t id = i;
			std::vector<size_t> coord(dim);
			size_t materialId;
			file >> materialId;
			for (int j = 1; j <= dim; j++) {
				file >> coord[j - 1];
			}
			boundaryFiniteElements.emplace_back(id, materialId, coord); 
		}
		file.close();
		std::cout << ".aneu file downloaded" << std::endl;
}
